=== debian/changelog ===
dwayland (5.25.0-kwayland.5.24.3) unstable; urgency=medium

  * add ECM to dev package

 -- Dingyuan Zhang <justforlxz@gmail.com>  Tue, 04 Apr 2023 14:43:28 +0800

dwayland (5.24.3-deepin.1.4) unstable; urgency=medium

  * Bug fix:
    + 146607 feat: remote-access protocol porting

 -- Lei Su <sulei@uniontech.com>  Tue, 15 Nov 2022 10:26:35 +0800

dwayland (5.24.3-deepin.1.3) unstable; urgency=medium

  * Bug fix:
    + fix: support set split mode when request split window use splitmenu

 -- Lei Su <sulei@uniontech.com>  Mon, 07 Nov 2022 16:39:02 +0800

dwayland (5.24.3-deepin.1.2) unstable; urgency=medium

  * Fix data control version error
  * Add datasource cache support

 -- Lei Su <sulei@uniontech.com>  Wed, 19 Oct 2022 17:05:39 +0800

dwayland (5.24.3-deepin.1.1) unstable; urgency=medium

  * splitscreen package 8 

 -- guokaka <guokaka@uniontech.com>  Mon, 15 Aug 2022 17:48:22 +0000

dwayland (5.24.3-deepin.1.0) unstable; urgency=medium

  * [Chaojiang Luo]
  * Init DDEShellSurfaceInterface parent QObject

 -- jccKevin <luochaojiang@uniontech.com>  Sat, 18 Jun 2022 16:21:54 +0800

dwayland (5.24.3-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (5.24.3).
  * Added myself to the uploaders.

 -- Aurélien COUDERC <coucouf@debian.org>  Thu, 10 Mar 2022 07:45:37 +0100

dwayland (5.24.2-2) unstable; urgency=medium

  [ Patrick Franz ]
  * Add missing Breaks for libkwin4-effect-builtins1.

 -- Patrick Franz <deltaone@debian.org>  Fri, 04 Mar 2022 18:53:25 +0100

dwayland (5.24.2-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (5.24.2).
  * Bump Standards-Version to 4.6.0 (no changes needed).
  * Re-export signing key without extra signatures.
  * Update B-Ds and deps with the info from cmake.
  * Update d/copyright.

 -- Patrick Franz <deltaone@debian.org>  Sat, 26 Feb 2022 21:58:53 +0100

dwayland (5.23.5-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (5.23.5).

 -- Patrick Franz <deltaone@debian.org>  Fri, 07 Jan 2022 15:43:55 +0100

dwayland (5.23.4-1) unstable; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.23.4).

 -- Patrick Franz <deltaone@debian.org>  Thu, 02 Dec 2021 20:24:37 +0100

dwayland (5.23.3-1) unstable; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.23.3).

 -- Norbert Preining <norbert@preining.info>  Wed, 10 Nov 2021 08:39:23 +0900

dwayland (5.23.2-1) unstable; urgency=medium

  [ Patrick Franz ]
  * Update upstream signing-key.

  [ Norbert Preining ]
  * New upstream release (5.23.1).
  * New upstream release (5.23.2).

 -- Norbert Preining <norbert@preining.info>  Wed, 03 Nov 2021 22:21:02 +0900

dwayland (5.23.0-1) unstable; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.23.0).
  * Bump plasma-wayland-protocols to 1.3.0.

 -- Norbert Preining <norbert@preining.info>  Thu, 14 Oct 2021 20:13:14 +0900

dwayland (5.21.5-2) unstable; urgency=medium

  [ Patrick Franz ]
  * Release to unstable.

 -- Patrick Franz <deltaone@debian.org>  Tue, 17 Aug 2021 03:24:01 +0200

dwayland (5.21.5-1) experimental; urgency=medium

  [ Patrick Franz ]
  * New upstream release (5.21.5).

 -- Patrick Franz <patfra71@gmail.com>  Fri, 07 May 2021 13:54:43 +0200

dwayland (5.21.4-1) experimental; urgency=medium

  [ Patrick Franz ]
  * New upstream release (5.21.4).

 -- Patrick Franz <patfra71@gmail.com>  Tue, 06 Apr 2021 17:47:03 +0200

dwayland (5.21.3-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.21.3).

 -- Norbert Preining <norbert@preining.info>  Wed, 17 Mar 2021 05:49:41 +0900

dwayland (5.21.2-1) experimental; urgency=medium

  [ Patrick Franz ]
  * New upstream release (5.21.2).

 -- Norbert Preining <norbert@preining.info>  Wed, 03 Mar 2021 05:33:49 +0900

dwayland (5.21.1-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.21.1).

 -- Norbert Preining <norbert@preining.info>  Wed, 24 Feb 2021 14:36:39 +0900

dwayland (5.21.0-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.21.0).

 -- Norbert Preining <norbert@preining.info>  Wed, 17 Feb 2021 05:42:27 +0900

dwayland (5.20.5-1) unstable; urgency=medium

  * New upstream release (5.20.5).

 -- Norbert Preining <norbert@preining.info>  Wed, 06 Jan 2021 23:50:52 +0900

dwayland (5.20.4-3) unstable; urgency=medium

  * Use virtual abi package to track versions (Closes: #978008)

 -- Norbert Preining <norbert@preining.info>  Mon, 28 Dec 2020 11:52:11 +0900

dwayland (5.20.4-2) unstable; urgency=medium

  * Release to unstable.

 -- Norbert Preining <norbert@preining.info>  Tue, 22 Dec 2020 11:04:37 +0900

dwayland (5.20.4-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (5.20.4).
  * Update (B-)Deps according to CMakeFiles.txt.
  * Update symbols.

 -- Norbert Preining <norbert@preining.info>  Wed, 09 Dec 2020 14:17:32 +0900

dwayland (5.19.5-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Sat, 24 Oct 2020 09:24:33 +0200

dwayland (5.19.5-1) experimental; urgency=medium

  * New upstream release (5.19.5).
  * Add Scarlett, Patrick, myself to uploaders.
  * Change maintainer to "Debian Qt/KDE ...".

 -- Norbert Preining <norbert@preining.info>  Fri, 23 Oct 2020 09:06:09 +0900

dwayland (5.19.4-2) unstable; urgency=medium

  * Upload to unstable.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update symbols file.

 -- Pino Toscano <pino@debian.org>  Sun, 18 Oct 2020 17:33:58 +0200

dwayland (5.19.4-1) experimental; urgency=medium

  * Initial packaging.

 -- Pino Toscano <pino@debian.org>  Tue, 18 Aug 2020 21:13:14 +0200
