=== archlinux/PKGBUILD ===
# Maintainer: justforlxz <justforlxz@gmail.com>
pkgname=dwayland-git
pkgver=5.24.3
pkgrel=1
sourcename=dwayland
sourcetars=("$sourcename"_"$pkgver".orig.tar.gz)
sourcedir="$sourcename"-"$pkgver"
pkgdesc='Qt-style Client and Server library wrapper for the Wayland libraries'
arch=(x86_64)
license=(LGPL)
depends=(qt5-wayland)
makedepends=('extra-cmake-modules' 'doxygen' 'qt5-tools' 'qt5-doc' 'wayland-protocols' 'deepin-wayland-protocols' 'ninja')
provides=('dwayland-reborn' 'dwayland')
conflicts=('dwayland-reborn' 'dwayland')
groups=('deepin-git')
source=("${sourcetars[@]}")
sha256sums=('SKIP')

build() {
  cd "$sourcedir"
  cmake . -G Ninja -B build \
    -DCMAKE_INSTALL_LIBEXECDIR=lib \
    -DBUILD_TESTING=OFF \
    -DBUILD_QCH=ON
  cmake --build build
}

package() {
  cd "$sourcedir"
  DESTDIR="$pkgdir" cmake --install build
}
